import pygame
import numpy as np
from Temps import *
from Image import transformImage

listeImage = [transformImage(pygame.image.load('../assets/Plantation/crop'+str(i)+'phase.png'), 120, 120) for i in range(1,5)]
iconStaticSize = (100,100)

#TODO : mettre une proba que les plantes meurent si il fait trop froid/chaud, et baisser cette proba de mourir avec une serre ou des torche pour l'hiver

class Champs:
    iconInsecteStatic = pygame.transform.scale(pygame.image.load("../assets/Plantation/leech.png"),(90,90))
    
    def __init__ (self, temperature, humidite, tempsAvantMaturation, pos, image):
        self.PourcentagePlanteFane = 10

        self.temperature = temperature
        self.humidite = humidite
        self.TAM = tempsAvantMaturation
        self.pos = np.array(pos)
        self.image = pygame.image.load(image)
        self.imageSize = np.array(self.image.get_size())
        self.rect = pygame.rect.Rect(self.pos, self.image.get_rect().size)
        self.rectScale = self.rect
        self.police = pygame.font.SysFont("Alef", 22) #pygame.font.get_fonts() -> liste des fonts
        self.imgZoom = pygame.transform.scale(self.image, self.imageSize)
        self.indiceImage = 0
        self.champZoom = pygame.rect.Rect(self.pos,self.imgZoom.get_rect().size)
        self.isInfeste = False
        
        self.descripteurChamps = {
            "Occupe" : None,
            #"Nom" : None

        }

        self.imageSurfaceinfo = {
            "Occupe" : None,
            #"Nom" : None
        }
        
        self.setInformation("Occupe", "Non")
        #self.setInformation("Nom",self.)


    def plantationGrandit(self):
        self.indiceImage += 1
        if self.indiceImage < 4:
            self.imageChamp = listeImage[self.indiceImage]
        else:
            if(self.indiceImage == 4):
                self.imageChamp = transformImage(pygame.image.load('../assets/Plantation/damage.png'), 120, 120)
            elif(self.indiceImage == 5):
                self.isInfeste = False
                self.imageChamp = transformImage(pygame.image.load('../assets/Plantation/fanne.png'), 120, 120)


    def draw (self, screen, camera):
        scaleImage = camera.scaleImage(self.image)

        if scaleImage: # != None
            self.imgZoom = scaleImage
            self.rectScale = pygame.rect.Rect(camera.convertLocation(self.pos), self.imgZoom.get_size())
            
        
        
        screen.blit(self.imgZoom, camera.convertLocation(self.pos))
        if hasattr(self,'imageChamp'):
            scaleChamp = camera.scaleImage(self.imageChamp)
            if scaleChamp:
                self.champZoom = scaleChamp
            varlongueur = camera.convertLocation(self.pos)   
            self.rectChampScal = pygame.rect.Rect(varlongueur, self.champZoom.get_size())
            screen.blit(
            self.champZoom, 
            (
                varlongueur[0] + 
                (self.rectScale.w-self.rectChampScal.w)
                /2,
                varlongueur[1] + 
                (self.rectScale.h-self.rectChampScal.h)
                /2)
            )
            self.setInformation("Occupe", "Oui")  

        if(self.isInfeste):
            scaleInfecte = camera.scaleImage(Champs.iconInsecteStatic)
            if scaleInfecte:
                self.infecteZoom = scaleInfecte
            varlongueur = camera.convertLocation(self.pos)   
            self.rectScalInfecte = pygame.rect.Rect(varlongueur, self.infecteZoom.get_size())
            screen.blit(
            self.infecteZoom, 
            (
                varlongueur[0] + 
                (self.rectScale.w-self.rectScalInfecte.w)
                /2,
                varlongueur[1] + 
                (self.rectScale.h-self.rectScalInfecte.h)
                /2)
            )
            

    def changeText (self, camera):
        scaleText = camera.scaleImage(self.text)
        if scaleText:
            self.zoomText = scaleText

    def setInformation(self,clef,valeur):
        self.descripteurChamps[clef] = valeur
        self.imageSurfaceinfo[clef] = police.render(clef+ " :  "+ str(valeur),False,(0,0,0))

    def showInfo(self,screen,rectangle):
        i = 0
        for k,v in self.descripteurChamps.items():
            screen.blit(self.imageSurfaceinfo[k],(rectangle.x,rectangle.y + i))
            i += 30

    def DeterminPourcentageFanage(self,montant):
        self.probaFanage +=montant
        

class Buisson (Champs):
    def __init__ (self, pos, prix = 10000):
        super().__init__(0, 0, 0, pos, '../assets/Interface/buissonCadenas.png')
        self.prix = prix
        self.text = self.police.render("Champ disponible à l'achat : " + str(self.prix), False, (0,0,0))
        self.zoomText = self.text
    
    def showInfo (self, screen,rectangle):
        screen.blit(self.text,(rectangle.x,rectangle.y))
    
    def buyField (self):
        return TerrainVide(self.pos)


class TerrainVide(Champs):
    def __init__ (self, pos):
        super().__init__(0, 0, 0, pos,'../assets/Plantation/champ.png')
        self.text = self.police.render("Température : " + str(self.temperature), False, (0,0,0))
        self.zoomText = self.text



class Houblon (Champs):
    iconStatic = transformImage(pygame.image.load('../assets/Plantation/houblon.png'), *iconStaticSize)
    textStatic = police.render('Houblon',False, (0,0,0))
    textDescriptionStatic = police.render("Houblon sa marche bien",False,(0,0,0))
    montantAchat = 250
    montantVente = 600
    def __init__ (self, pos):
        super().__init__(0, 0, 0, pos,'../assets/Plantation/champ.png')
        self.text = self.police.render("Température : " + str(self.temperature), False, (0,0,0))
        self.zoomText = self.text

        self.imageChamp = transformImage(pygame.image.load('../assets/Plantation/crop1phase.png'), 120, 120)
        
        
class Ble (Champs):
    iconStatic = transformImage(pygame.image.load('../assets/Plantation/wheat.png'), *iconStaticSize)
    textStatic = police.render('Ble',False, (0,0,0))
    textDescriptionStatic = police.render("Ble sa marche bien",False,(0,0,0))
    montantAchat = 250
    montantVente = 800
    def __init__ (self,pos):
        super().__init__(0,0,0,pos,'../assets/Plantation/champ.png')
        
        self.imageChamp = transformImage(pygame.image.load('../assets/Plantation/crop1phase.png'), 120, 120)

class Malt (Champs):
    iconStatic = transformImage(pygame.image.load('../assets/Plantation/malt.png'), *iconStaticSize)
    textStatic = police.render('Malt',False, (0,0,0))
    textDescriptionStatic = police.render("Malt sa marche bien",False,(0,0,0))
    montantAchat = 300
    montantVente = 800
    def __init__ (self,pos):
        super().__init__(0,0,0,pos,'../assets/Plantation/champ.png')
        self.imageChamp = transformImage(pygame.image.load('../assets/Plantation/crop1phase.png'), 120, 120)


class Chanvre(Champs):
    iconStatic = transformImage(pygame.image.load('../assets/Plantation/weed.png'), *iconStaticSize)
    textStatic = police.render("Chanvre",False, (0,0,0))
    textDescriptionStatic = police.render("Pour des spaces bières",False,(0,0,0))
    montantAchat = 1000
    montantVente = 5000
    def __init__ (self,pos):
        super().__init__(0,0,0,pos,'../assets//Plantation/champ.png')
        self.imageChamp = transformImage(pygame.image.load('../assets/Plantation/crop1phase.png'), 120, 120)


class OrgeHiver(Champs):
    iconStatic = transformImage(pygame.image.load('../assets/Plantation/orge.png'), *iconStaticSize)
    textStatic = police.render("Orge hiver",False, (0,0,0))
    textDescriptionStatic = police.render("Orge hiver sa marche bien",False,(0,0,0))
    montantAchat = 300
    montantVente = 800
    def __init__ (self,pos):
        super().__init__(0,0,0,pos,'../assets/Plantation/champ.png')
        self.imageChamp = transformImage(pygame.image.load('../assets/Plantation/crop1phase.png'), 120, 120)


class OrgePrintemps(Champs):
    iconStatic = transformImage(pygame.image.load('../assets/Plantation/OrgePrintemps.png'), *iconStaticSize)
    textStatic = police.render("Orge printemps",False, (0,0,0))
    textDescriptionStatic = police.render("Orge printemps sa marche bien",False,(0,0,0))
    montantAchat = 500
    montantVente = 1000
    def __init__ (self,pos):
        super().__init__(0,0,0,pos,'../assets/Plantation/champ.png')
        
        self.imageChamp = transformImage(pygame.image.load('../assets/Plantation/crop1phase.png'), 120, 120)


class Seigle(Champs):
    iconStatic = transformImage(pygame.image.load('../assets/Plantation/seigle.png'), *iconStaticSize)
    textStatic = police.render("Seigle",False, (0,0,0))
    textDescriptionStatic = police.render("Seigle sa marche bien",False,(0,0,0))
    montantAchat = 200
    montantVente = 600
    def __init__ (self,pos):
        super().__init__(0,0,0,pos,'../assets/Plantation/champ.png')
        self.imageChamp = transformImage(pygame.image.load('../assets/Plantation/crop1phase.png'), 120, 120)


class Pesticide(Champs):
    iconStatic = transformImage(pygame.image.load('../assets/Plantation/pesticide.png'), *iconStaticSize)
    textStatic = police.render("Pesticide",False, (0,0,0))
    textDescriptionStatic = police.render("Pour tuer les insectes",False,(0,0,0))
    montantAchat = 200
    def __init__ (self,pos):
        super().__init__(0,0,0,pos,'../assets/Plantation/pesticide.png')

#TODO : class Bussion,

typePlantation = [Houblon,Ble,Malt,Chanvre,OrgeHiver,OrgePrintemps,Seigle,Pesticide]
    
        